from abc import ABC
from typing import Any, Union

from llama_index.vector_stores.types import BasePydanticVectorStore, VectorStore
from unstract.adapters.base import Adapter
from unstract.adapters.enums import AdapterTypes


class VectorDBAdapter(Adapter, ABC):
    def __init__(self, name: str):
        super().__init__(name)
        self.name = name

    @staticmethod
    def get_id() -> str:
        return ""

    @staticmethod
    def get_name() -> str:
        return ""

    @staticmethod
    def get_description() -> str:
        return ""

    @staticmethod
    def get_icon() -> str:
        return ""

    @staticmethod
    def get_json_schema() -> str:
        return ""

    @staticmethod
    def get_adapter_type() -> AdapterTypes:
        return AdapterTypes.VECTOR_DB

    def get_vector_db_instance(
        self, vector_db_config: dict[str, Any]
    ) -> Union[BasePydanticVectorStore, VectorStore, None]:
        return None

    def delete_collection(self) -> None:
        """Override to delete.

        Returns:
            bool: Flag indicating if the credentials are valid or not
        """
        pass
